<?php
/**
 * A class for rendering inputs of type radio.
 */
class form_widget_radio extends form_widget_input
{
    ////////////////////////////////////////////////////////////////////////////
    // Construct and destruct functions.

    ////////////////////////////////////////////////////////////////////////////
    // Overload functions.

    ////////////////////////////////////////////////////////////////////////////
    // Interface functions.

    /**
     * Renders inputs of type radio.
     *
     * @param array (optional) $option The options.
     * @key string 'value' The checked option.
     * @key array 'option' The options.
     * @key string * A radio attribute.
     * @throws invalidargumentexception If the 'option' key is not an array.
     * @return string The rendered input.
     */
    public static function render(array $option = array())
    {
        $value = (array_key_exists('value', $option)) ? $option['value'] : '';
        $list = (array_key_exists('option', $option)) ? $option['option'] : array();
        
        if (!is_array($list))
        {
            throw new invalidargumentexception('Argument 1 (key \'option\') passed to ' . __METHOD__ . '() must be an array, ' . gettype($list) . ' given.');
        }
        
        unset($option['value'], $option['option']);
        $option['type'] = 'radio';
        $radio = array();
        
        foreach ($list as $k => $v)
        {
            $option['value'] = $k;
            
            if ($value == $k)
            {
                $option['checked'] = 'checked';
            }
            else
            {
                unset($option['checked']);
            }
            
            $radio[] = parent::render($option) . htmlspecialchars($v);
        }
        
        return implode('<br />', $radio);
    }
    
    ////////////////////////////////////////////////////////////////////////////
    // Internal functions.
}
